// sxstring.c : show the use of string.h functions on SX
//  
//                    note the SX-Key break in the C dobreak() function
//
#pragma chip SX28 // select device

// SX-KEY specific settings:
/*<?asm
	DEVICE	turbo
	DEVICE	optionx
	DEVICE	stackx
	DEVICE	OSCHS3
	IRC_CAL	IRC_FAST
	FREQ	50_000_000
	RESET   main
?>*/



// ************************************************
// ************************************************
// MACRO DEFINITIONS AND CONSTANTS

// ************************************************
// ************************************************
// IO PORT DEFINITIONS

// ************************************************
// ************************************************
// GLOBAL VARIABLE DEFINITIONS

// a bank type modifier overrides the current rambank
// bank4 uns16 u16, table1[3];  // located in ram bank 4


// ************************************************
// ************************************************
// PROTOTYPES AND CODEPAGES
#pragma codepage 1
void doit(void);

// ************************************************
// ************************************************
// INTERRUPT SUPPORT

#pragma origin 0   // interrupt must be located first on codepage 0

// ************************************************
// ************************************************
// INCLUDED C FILES AND MATH ROUTINES

/* Functions located in codepage 0 need to be included after the
interrupt routine. However, if the functions are not located in
codepage 0, then they can be included before the interrupt routine.
Using #pragma codepage ensures that functions not yet located (by
page modifier or #pragma location) are put on certain codepages */

// put functions in code page 0
// SXIO.H must be in 0 -- it contains the interrupt handler....
#include <SXIO.H>

#pragma codepage 3
// #include <string2.h>
#include <stdlib2.h>

#pragma codepage 0
#pragma rambank -

// ************************************************
// ************************************************
// C FUNCTIONS

void dobreak(void) {
	/*<?asm
	 break
	 ?>*/
}

#pragma codepage 0
void main(void){
	doit();
}

#pragma codepage 1
void doit(void){

	int result;
	int result2;
	
	static const char lit1[3] = "C4";
	char *ptr;
	
	bank2 char buffer1[16];
	bank3 char buffer2[16];
	bank4 char buffer3[16];
	bank5 char buffer4[16];
	
    clearRAM();  // built in function

	buffer1[0] = 'C';
	buffer1[1] = '4';
	buffer1[2] = 0x0;
	buffer2[0] = 'S';
	buffer2[1] = 'X';
	buffer2[2] = 0x0;
	
	strcpy(buffer3,buffer1);
	strcat(buffer3,buffer2);
	result = strlen(buffer3);
	itoa(result,buffer4);
	
	// ptr = (char *) lit1;
	result2 = strlen(lit1);
	
	dobreak();
	
	serial_on(100);
	puts("\n\rbuffer3 length is: ");
	puts(buffer4);
	puts("\n\rbuffer3 contents: ");
	puts(buffer3);
	puts("\n\rlit1 length is: ");
	itoa(result2,buffer4);
	puts(buffer4);
	puts("\n\rlit1 contents: ");
	puts(lit1);	
	serial_off();
	
	dobreak();

}

